import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { OaAppUser, OaAppUserParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询应用成员
 */
export async function pageOaAppUser(params: OaAppUserParam) {
  const res = await request.get<ApiResult<PageResult<OaAppUser>>>(
    MODULES_API_URL + '/oa/oa-app-user/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询应用成员列表
 */
export async function listOaAppUser(params?: OaAppUserParam) {
  const res = await request.get<ApiResult<OaAppUser[]>>(
    MODULES_API_URL + '/oa/oa-app-user',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加应用成员
 */
export async function addOaAppUser(data: OaAppUser) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/oa/oa-app-user',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改应用成员
 */
export async function updateOaAppUser(data: OaAppUser) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/oa/oa-app-user',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除应用成员
 */
export async function removeOaAppUser(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/oa/oa-app-user/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除应用成员
 */
export async function removeBatchOaAppUser(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/oa/oa-app-user/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询应用成员
 */
export async function getOaAppUser(id: number) {
  const res = await request.get<ApiResult<OaAppUser>>(
    MODULES_API_URL + '/oa/oa-app-user/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
